searchNodes=[{"doc":"Authentication library for Phoenix, and other Plug-based, web applications.Phauxth is designed to be secure, extensible and well-documented.Phauxth offers two types of functions: Plugs, which are called with plug, and verify/2 functions.PlugsPlugs take a conn (connection) struct and opts as arguments and return a conn struct.AuthenticatePhauxth.Authenticate checks to see if there is a session_id in the current session and sets the current_user value accordingly.AuthenticateTokenPhauxth.AuthenticateToken checks to see if there is an authorization token in the headers, verifies it, and sets the current_user value accordingly.RememberPhauxth.Remember checks to see if there is a valid remember_me cookie. If there is one, it verifies the cookie and, if the verification is successful, adds the user to the session.Phauxth verify/2The verify/2 functions take a map (usually Phoenix params) and opts (an empty list by default) and return {:ok, user} or {:error, message}.LoginPhauxth.Login.verify is used for user login.User confirmationPhauxth.Confirm.verify is used for email confirmation.Password resettingPhauxth.Confirm.PassReset.verify is used for password resetting.Phauxth with a new Phoenix projectThe easiest way to get started is to use the phauxth_new installer. First, download and install it:mix archive.install https://github.com/riverrun/phauxth_installer/raw/master/archives/phauxth_new.ezThen run the mix phauxth.new command in the main directory of the Phoenix app. The following options are available:--api - create files for an api--confirm - add files for email confirmation--remember - add remember_me functionality--backups - create backup files, with .bak extension, before writing new filesPhauxth uses the user_context module to communicate with the underlying database. This value needs to be set in the config. See the documentation for Phauxth.Config.user_context for details.In addition, the user_context module needs to have a get_by(attrs) function defined (see the examples below).@spec get_by(map) :: User.t() | nil def get_by(%{&quot;session_id&quot; =&gt; session_id}) do with %Session{user_id: user_id} &lt;- Sessions.get_session(session_id), do: get_user(user_id) end def get_by(%{&quot;email&quot; =&gt; email}) do Repo.get_by(User, email: email) endCustomizing PhauxthSee the documentation for Phauxth.Authenticate.Base, Phauxth.Authenticate.Token and Phauxth.Confirm.Base for more information on extending these modules.You can also find more information at the Phauxth wiki.","ref":"Phauxth.html","title":"Phauxth","type":"behaviour"},{"doc":"Authenticates the user based on the user params.After performing the relevant checks, this function also gets the user data (if available).","ref":"Phauxth.html#c:authenticate/3","title":"Phauxth.authenticate/3","type":"callback"},{"doc":"Logs the result of the verification and returns {:ok, user} or {:error, message}.","ref":"Phauxth.html#c:report/2","title":"Phauxth.report/2","type":"callback"},{"doc":"Verifies the user based on the user params.In the default implementations - Confirm.Base and Login.Base, this function calls the authenticate function with the user params and pipes the output to the report function.","ref":"Phauxth.html#c:verify/2","title":"Phauxth.verify/2","type":"callback"},{"doc":"","ref":"Phauxth.html#t:ok_or_error/0","title":"Phauxth.ok_or_error/0","type":"type"},{"doc":"Authenticates the current user using sessions.This module checks the current Plug session for a phauxth_session_id, checks to see if the session id is valid and then sets the current_user value accordingly.For information about customizing this Plug, see the documentation for Phauxth.Authenticate.Base.Configuration / setupAdd the user_context module (the module you are using to handle user data) to the config:config :phauxth, user_context: MyApp.AccountsThe user_context module (in this case, MyApp.Accounts) needs to have a get_by(%{&quot;session_id&quot; =&gt; session_id}) function, which returns either a user struct or nil.In the example below, the Sessions.get_session/1 function retrieves the data and checks if the session is still valid (has not expired, etc.).def get_by(%{&quot;session_id&quot; =&gt; session_id}) do with %Session{user_id: user_id} &lt;- Sessions.get_session(session_id), do: get_user(user_id) endOptionsThere are two options::user_context - the user_context modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword listExamplesAdd the following line to the pipeline you want to authenticate in the web/router.ex file:plug Phauxth.Authenticate","ref":"Phauxth.Authenticate.html","title":"Phauxth.Authenticate","type":"module"},{"doc":"","ref":"Phauxth.Authenticate.html#get_user/2","title":"Phauxth.Authenticate.get_user/2","type":"function"},{"doc":"Base module for authentication.This is use-d by Phauxth.Authenticate and Phauxth.Remember, and it is extended by Phauxth.Authenticate.Token.This module can also be used to produce a custom authentication module, as outlined below.Custom authentication modulesThe next section gives examples of extending this module to create custom authentication modules.ExamplesAuthentication for use with Phoenix channelsIn this example, after adding the user struct to the current_user value, a token is added to the conn.defmodule MyAppWeb.ChannelAuthenticate do use Phauxth.Authenticate.Base def set_user(nil, conn), do: assign(conn, :current_user, nil) def set_user(user, conn) do token = MyAppWeb.Token.sign(%{&quot;user_id&quot; =&gt; user.email}) user |&gt; super(conn) |&gt; assign(:user_token, token) end endMyAppWeb.ChannelAuthenticate is called in the same way as Phauxth.Authenticate.You can then use MyAppWeb.Token.verify, in the user_socket.ex file, to verify the token - see the documentation for Phauxth.Token for information about how to create the MyAppWeb.Token module.","ref":"Phauxth.Authenticate.Base.html","title":"Phauxth.Authenticate.Base","type":"behaviour"},{"doc":"Gets the user based on the session or token data.In the default implementation, this function also retrieves user information using the get_by function defined in the user_context module.","ref":"Phauxth.Authenticate.Base.html#c:authenticate/3","title":"Phauxth.Authenticate.Base.authenticate/3","type":"callback"},{"doc":"Logs the result of the authentication and returns the user struct or nil.","ref":"Phauxth.Authenticate.Base.html#c:report/2","title":"Phauxth.Authenticate.Base.report/2","type":"callback"},{"doc":"Sets the current_user variable.","ref":"Phauxth.Authenticate.Base.html#c:set_user/2","title":"Phauxth.Authenticate.Base.set_user/2","type":"callback"},{"doc":"Base module for remember me functionality.This is use-d by Phauxth.Remember, and it can also be used to produce a custom remember me module.","ref":"Phauxth.Authenticate.Remember.html","title":"Phauxth.Authenticate.Remember","type":"module"},{"doc":"Base module for token authentication.This is use-d by Phauxth.AuthenticateToken, and it can also be used to produce a custom token authentication module, as outlined below.Custom token authentication modulesThe next sections give examples of extending this module to create custom authentication modules.Token authentication with token stored in a cookieThis module will retrieve the token from a cookie, instead of from the headers:defmodule Phauxth.AuthenticateTokenCookie do use Phauxth.Authenticate.Token @impl true def authenticate(%Plug.Conn{req_cookies: %{&quot;access_token&quot; =&gt; token}}, user_context, opts) do verify_token(token, user_context, opts) end endAnd in the router.ex file, call this plug in the pipeline you want to authenticate.pipeline :api do plug :accepts, [&quot;json&quot;] plug AuthenticateTokenCookie endGraphQL authenticationThe following module is an example of how Phauxth.Authenticate.Token module can be extended, this time to provide authentication for absinthe-elixir:defmodule AbsintheAuthenticate do use Phauxth.Authenticate.Token @impl true def set_user(user, conn) do Absinthe.Plug.put_options(conn, context: %{current_user: user}) end endAs in the above example, in the router.ex file, call this plug in the pipeline you want to authenticate.","ref":"Phauxth.Authenticate.Token.html","title":"Phauxth.Authenticate.Token","type":"behaviour"},{"doc":"Gets the token from the authorization headers.","ref":"Phauxth.Authenticate.Token.html#c:get_token/3","title":"Phauxth.Authenticate.Token.get_token/3","type":"callback"},{"doc":"Authenticates the user by verifying a Phauxth token.This module looks for a token in the request headers, checks to see if the token is valid and then sets the current_user value accordingly.If you want to store the token in a cookie, or customize this Plug in any other way, see the documentation for Phauxth.Authenticate.Token.Configuration / setupAdd the user_context module (the module you are using to handle user data) to the config:config :phauxth, user_context: MyApp.AccountsThe user_context module (in this case, MyApp.Accounts) needs to have a get_by(attrs) function, which returns either a user struct or nil.You also need to define a token module that implements the Phauxth.Token behaviour. See the documentation for the Phauxth.Token module for details.OptionsThere are four main options::user_context - the user_context modulethis can also be set in the config:token_module - the token modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword list:max_age - the maximum age for the tokenthe default is 14_400 seconds - 4 hoursThe options keyword list is also passed to the token verify function. See the documentation for Phauxth.Token for information about defining and setting the token module.ExamplesAdd the following line to the pipeline you want to authenticate in the web/router.ex file:plug Phauxth.AuthenticateTokenTo set the max_age to two hours:plug Phauxth.AuthenticateToken, max_age: 7200","ref":"Phauxth.AuthenticateToken.html","title":"Phauxth.AuthenticateToken","type":"module"},{"doc":"","ref":"Phauxth.AuthenticateToken.html#get_user/2","title":"Phauxth.AuthenticateToken.get_user/2","type":"function"},{"doc":"This module provides an abstraction layer for configuration.The following are valid configuration items.nametypedefaultuser_contextmoduleN/Acrypto_modulemoduleN/Atoken_modulemoduleN/Alog_levelatom:infouser_messagesmodulePhauxth.UserMessagesdrop_user_keyslist of atoms[]ExamplesAdd a phauxth entry to the config.exs file in your project, as in the following example:config :phauxth, user_context: MyApp.Users, crypto_module: Argon2, token_module: MyAppWeb.Auth.Token","ref":"Phauxth.Config.html","title":"Phauxth.Config","type":"module"},{"doc":"The module used to verify passwords.This is used by the Phauxth.Login module.","ref":"Phauxth.Config.html#crypto_module/0","title":"Phauxth.Config.crypto_module/0","type":"function"},{"doc":"The keys that are removed from the user struct before it is passed on to another function.This should be a list of atoms.By default, :password_hash, :encrypted_password, :password and :otp_secret are removed, and this option allows you to add to this list.","ref":"Phauxth.Config.html#drop_user_keys/0","title":"Phauxth.Config.drop_user_keys/0","type":"function"},{"doc":"Generates a random salt for use with token authentication.If you are using tokens in your app, and the token implementation uses salts, you can use this function to generate random salts.","ref":"Phauxth.Config.html#gen_token_salt/1","title":"Phauxth.Config.gen_token_salt/1","type":"function"},{"doc":"The log level for Phauxth logs.This can be false, :debug, :info, :warn or :error.The default is :info, which means that :info, :warn and :error logs will be returned.You can turn off the Phauxth logs by setting this value to false.","ref":"Phauxth.Config.html#log_level/0","title":"Phauxth.Config.log_level/0","type":"function"},{"doc":"The module used to sign and verify tokens.This module must implement the Phauxth.Token behaviour. See the documentation for Phauxth.Token for more information.","ref":"Phauxth.Config.html#token_module/0","title":"Phauxth.Config.token_module/0","type":"function"},{"doc":"The users module to be used when querying the database.This module needs to have a get_by(attrs) function defined, which is used to fetch the relevant data.","ref":"Phauxth.Config.html#user_context/0","title":"Phauxth.Config.user_context/0","type":"function"},{"doc":"Module to be used to display messages to users.The default is Phauxth.UserMessages. See the documentation for Phauxth.UserMessages.Base for details about customizing / translating these messages.","ref":"Phauxth.Config.html#user_messages/0","title":"Phauxth.Config.user_messages/0","type":"function"},{"doc":"Module to provide user confirmation for new users.OptionsThere are four main options::user_context - the user_context modulethis can also be set in the config:token_module - the token modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword list:max_age - the maximum age for the tokenthe default is 720 seconds - 20 minutesThe options keyword list is also passed to the token verify function. See the documentation for Phauxth.Token for information about defining and setting the token module.","ref":"Phauxth.Confirm.html","title":"Phauxth.Confirm","type":"module"},{"doc":"Base module for handling user confirmation.This is used by Phauxth.Confirm and Phauxth.Confirm.PassReset, and it can also be used to create custom user confirmation modules.","ref":"Phauxth.Confirm.Base.html","title":"Phauxth.Confirm.Base","type":"behaviour"},{"doc":"Gets the user data from the database.","ref":"Phauxth.Confirm.Base.html#c:get_user/2","title":"Phauxth.Confirm.Base.get_user/2","type":"callback"},{"doc":"Module to provide user confirmation when resetting passwords.OptionsThere are two options::user_context - the user_context modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword listThere are also options for verifying the token. See the documentation for the Phauxth.Token module for details.","ref":"Phauxth.Confirm.PassReset.html","title":"Phauxth.Confirm.PassReset","type":"module"},{"doc":"Logging functions for Phauxth.FormatPhauxth uses logfmt to provide a standard logging format. 15:31:08.575 [warn] user=ray@example.com message=&quot;invalid password&quot;:user - the user identifier (one of email, username, nil):message - error / info message:meta - additional metadata that does not fit into any of the other categoriesthis should be a keyword listLog levelsThe available log levels are :info, :warn and false.The level at which logging starts can be configured by changing the log_level value in the config file.The default log_level is :info, but if you only want warnings printed out, add the following to the config file:config :phauxth, log_level: :warnAnd if you do not want Phauxth to print out any logs, set the log_level to false.","ref":"Phauxth.Log.html","title":"Phauxth.Log","type":"module"},{"doc":"Returns the id of the currently logged-in user, if present.","ref":"Phauxth.Log.html#current_user_id/1","title":"Phauxth.Log.current_user_id/1","type":"function"},{"doc":"Returns the debug log message.","ref":"Phauxth.Log.html#debug/1","title":"Phauxth.Log.debug/1","type":"function"},{"doc":"Returns the error log message.","ref":"Phauxth.Log.html#error/1","title":"Phauxth.Log.error/1","type":"function"},{"doc":"Returns the info log message.","ref":"Phauxth.Log.html#info/1","title":"Phauxth.Log.info/1","type":"function"},{"doc":"Returns the warn log message.","ref":"Phauxth.Log.html#warn/1","title":"Phauxth.Log.warn/1","type":"function"},{"doc":"Module to login users.Before using this module, you will need to add the crypto_module value to the config. The crypto_module must implement the Comeonin behaviour.OptionsThere are two options::user_context - the user_context modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword listThere are also options for verifying the password. See the documentation for the crypto_module's check_pass function for details.","ref":"Phauxth.Login.html","title":"Phauxth.Login","type":"module"},{"doc":"Base module for handling login.This is used by Phauxth.Login and can also be used to create custom login modules.Custom login modulesOne example of a custom login module is shown below:defmodule MyApp.LoginConfirm do use Phauxth.Login.Base @impl true def authenticate(%{&quot;password&quot; =&gt; password} = params, user_context, opts) do case user_context.get_by(params) do nil -&gt; {:error, &quot;no user found&quot;} %{confirmed_at: nil} -&gt; {:error, &quot;account unconfirmed&quot;} user -&gt; Config.crypto_module().check_pass(user, password, opts) end end endIn this example, the authenticate function is overridden to check the user struct to see if the user is confirmed. If the user has not been confirmed, an error is returned.","ref":"Phauxth.Login.Base.html","title":"Phauxth.Login.Base","type":"module"},{"doc":"Remember me module.Checks for a remember_me cookie, which contains a token. The token is then checked, and if it is valid, the user is added to the session.This module also contains functions to add / delete the remember_me cookie.If you want to customize this Plug in any way, see the documentation for Phauxth.Authenticate.Remember.Configuration / setupAdd the user_context module (the module you are using to handle user data) to the config:config :phauxth, user_context: MyApp.AccountsThe user_context module (in this case, MyApp.Accounts) needs to have a get_by(attrs) function, which returns either a user struct or nil, and a create_session(user) function, which returns {:ok, session} or {:error, message}.You also need to define a token module that implements the Phauxth.Token behaviour. See the documentation for the Phauxth.Token module for details.OptionsThere are four main options::user_context - the user_context modulethis can also be set in the config:token_module - the token modulethis can also be set in the config:log_meta - additional custom metadata for Phauxth.Logthis should be a keyword list:max_age - the maximum age for the tokenthe default is 604_800 seconds - 1 weekThe options keyword list is also passed to the token verify function. See the documentation for Phauxth.Token for information about defining and setting the token module.ExamplesAdd the following line to the pipeline you want to authenticate in the web/router.ex file:plug Phauxth.Authenticate plug Phauxth.RememberMake sure you add the Phauxth.Remember Plug after Phauxth.Authenticate.","ref":"Phauxth.Remember.html","title":"Phauxth.Remember","type":"module"},{"doc":"Adds a remember me cookie to the conn.","ref":"Phauxth.Remember.html#add_rem_cookie/6","title":"Phauxth.Remember.add_rem_cookie/6","type":"function"},{"doc":"Deletes the remember_me cookie from the conn.","ref":"Phauxth.Remember.html#delete_rem_cookie/1","title":"Phauxth.Remember.delete_rem_cookie/1","type":"function"},{"doc":"","ref":"Phauxth.Remember.html#get_user/2","title":"Phauxth.Remember.get_user/2","type":"function"},{"doc":"Behaviour for signing and verifying tokens.If you are using Phauxth for token authentication, email confirmation or password resetting, you will need to define a module in your app that uses this behaviour (see the examples section below).After you have created the token module, add the token_module value to the phauxth config:config phauxth, token_module: MyAppWeb.Auth.TokenUse the token module to sign the tokens, and then Phauxth will use this module to verify the tokens.ExamplesThe following is an example token module using Phoenix tokens.defmodule MyAppWeb.Auth.Token do @behaviour Phauxth.Token alias Phoenix.Token alias MyAppWeb.Endpoint @token_salt &quot;JaKgaBf2&quot; @impl true def sign(data, opts \\ []) do Token.sign(Endpoint, @token_salt, data, opts) end @impl true def verify(token, opts \\ []) do Token.verify(Endpoint, @token_salt, token, opts) end end","ref":"Phauxth.Token.html","title":"Phauxth.Token","type":"behaviour"},{"doc":"Signs a token.","ref":"Phauxth.Token.html#c:sign/2","title":"Phauxth.Token.sign/2","type":"callback"},{"doc":"Verifies a token.","ref":"Phauxth.Token.html#c:verify/2","title":"Phauxth.Token.verify/2","type":"callback"},{"doc":"","ref":"Phauxth.Token.html#t:data/0","title":"Phauxth.Token.data/0","type":"type"},{"doc":"","ref":"Phauxth.Token.html#t:opts/0","title":"Phauxth.Token.opts/0","type":"type"},{"doc":"","ref":"Phauxth.UserMessages.html","title":"Phauxth.UserMessages","type":"module"},{"doc":"Callback implementation for Phauxth.UserMessages.Base.already_confirmed/0.","ref":"Phauxth.UserMessages.html#already_confirmed/0","title":"Phauxth.UserMessages.already_confirmed/0","type":"function"},{"doc":"Callback implementation for Phauxth.UserMessages.Base.default_error/0.","ref":"Phauxth.UserMessages.html#default_error/0","title":"Phauxth.UserMessages.default_error/0","type":"function"},{"doc":"Callback implementation for Phauxth.UserMessages.Base.invalid_token/0.","ref":"Phauxth.UserMessages.html#invalid_token/0","title":"Phauxth.UserMessages.invalid_token/0","type":"function"},{"doc":"Customizable module to be used to display messages to users.These messages can be customized to display different messages or add translations using gettext.Custom messagesThe following module is a basic example of how to translate the user messages that Phauxth outputs:defmodule MyApp.UserMessages do use Phauxth.UserMessages.Base import MyApp.Gettext def default_error, do: gettext &quot;Invalid credentials&quot; end","ref":"Phauxth.UserMessages.Base.html","title":"Phauxth.UserMessages.Base","type":"behaviour"},{"doc":"","ref":"Phauxth.UserMessages.Base.html#c:already_confirmed/0","title":"Phauxth.UserMessages.Base.already_confirmed/0","type":"callback"},{"doc":"","ref":"Phauxth.UserMessages.Base.html#c:default_error/0","title":"Phauxth.UserMessages.Base.default_error/0","type":"callback"},{"doc":"","ref":"Phauxth.UserMessages.Base.html#c:invalid_token/0","title":"Phauxth.UserMessages.Base.invalid_token/0","type":"callback"}]